mod aliens;
mod collision;
mod motion;
mod player;
mod spawning;

mod _plugin {
	use bevy::app::App;
	use bevy::prelude::Plugin;

	pub struct EntityPlugin;
	impl Plugin for EntityPlugin {
		fn build(&self, app: &mut App) {
			app.add_startup_systems((
				super::player::spawn_player,
				super::aliens::spawn_static_aliens,
			))
			.add_systems((
				super::player::process_player_input,
				super::motion::apply_velocity,
				super::spawning::apply_despawn_boundaries,
				super::collision::check_entity_collisions,
			));
		}
	}
}

pub use _plugin::EntityPlugin;
pub use collision::{check_box_collisions, BoxSize, CollisionGroup};
pub use motion::{Velocity, DIR_LEFT, DIR_RIGHT};
pub use player::Player;
pub use spawning::{DespawnOffScreen, EntitySpawner};
